# VisualizationCNN
Visualization CNN model by Keras.

## Requirement
- Python 3.6 
- Keras 2.2.2
- Tensorflow-gpu 1.8.0  
- OpenCV 3.4

## Support model
- VGG16
- VGG19
- ResNet50
- InceptionV3
- Xception
- MobileNet
- DenseNet121

## Visualization (VGG16 example)
**Visualizing intermediate conv outputs**
![conv_block1_conv1](images/conv_block1_conv1.jpg)
![conv_block2_conv2](images/conv_block2_conv2.jpg)
![conv_block3_conv3](images/conv_block3_conv3.jpg)
![conv_block3_conv3](images/conv_block4_conv3.jpg)

**Visualizing conv filters**
![filter_block1_conv1](images/filter_block1_conv1.jpg)
![filter_block2_conv2](images/filter_block2_conv2.jpg)
![filter_block2_conv2](images/filter_block3_conv3.jpg)
![filter_block2_conv2](images/filter_block4_conv3.jpg)

**Visualizing heatmaps of class activation in an image**
![heatmap](images/heatmap.jpg)

